 //+------------------------------------------------------------------+
//|                                           UNIVERSAL TREND LINE EA |
//|                                                     Ogie Dimitrov |
//|                                                  ogidimi@gmail.com|
//+-------------------------------------------------------------------+
#include <Trade\Trade.mqh>
#include <Trade\SymbolInfo.mqh>
#include <Trade\PositionInfo.mqh>
#include <Trade\AccountInfo.mqh>
#include <Indicators\TimeSeries.mqh>
#include <Indicators\Trend.mqh>
#include <Indicators\Oscilators.mqh>
//+-------------------------------------------------------------------+
enum ENUM_LINE_SLOPE
{
   SLOPE_UP = 1,
   SLOPE_DOWN = -1,
   SLOPE_NONE = 0
};

// TOP TRENDLINE SETTINGS
input double  risk = 0.5;        
input double  lotSize = 0.1;              
input int      stocLevel = 50;
input bool     haEntry = false;
input bool     haTrail = true;           
input int     StepUP_DN = 5;          
string  entryHLINE = "entry";
string  tpHLINE = "tp";       
string  slHLINE = "sl";    
string  beLINE = "be";
string  topTrendLine = "ttl";       
input bool     ttlBounce = false;
input bool     ttlBreakout = false;
string  bottomTrendLine = "btl";    
input bool     btlBreakout = false;
input bool     btlBounce = false;
input bool     EveryTickTS = false;

//COMMON SETINGS - APPLIED TO BOTH TOP AND BOTTOM TRENDLINES
bool    useTrailingStop = true;  
//int     atrPeriod = 13;             
//double  atrMultiplier = 0;    
input int              MAPeriod  =  1;             
ENUM_MA_METHOD   MAMethod  =  MODE_SMMA;    
input int              SmPeriod  =  1;           
ENUM_MA_METHOD   SmMethod  =  MODE_LWMA;    
  
input int   BarsForSL = 13;    
input double        maxNumberOfEntries=1;       
int     MagicNumber = 1500;
input int     kPeriod  = 13;
input int     dPeriod = 3;
input int     Slowing = 8;
ENUM_MA_METHOD stocMAmethod = 0;
ENUM_STO_PRICE stocPrice = 1;
int     stocShift = 0;

//+------------------------------------------------------------------+
CTrade trade;                             // this mt5 built in class will manage trade functions
string magicLong =   "long HTL";          // magic for long trades trigered by the bottom trendline
string magicShort =  "short HTL";        // magic for short trades trigered by the bottom trendline
int DecimalPoints;
double point;
double O,O1,O2,  H,H1,H2,   L,L1,L2 ,C,C1,C2;                        // Close prices for bars 1,2,3
double haC, haC1, haO, haO1, haH, haH1, haL, haL1;                    
double topUL, topML, topLL;
double botUL, botML, botLL;
ENUM_LINE_SLOPE ttlSlope, btlSlope;

double tpUL, tpML, tpLL;
double slUL, slML, slLL;
double entryUL, entryML, entryLL;
double hpcUL, hpcML, hpcLL;

double   stocmain,stocsignal,stocsignal1;
int AtrHandle;
int haHandle, BarsAgo = 500;;
double haCBuffer[],haHBuffer[],haLBuffer[],haOBuffer[];
static datetime lastexec_minute;
//+------------------------------------------------------------------+
void OnInit()
{  
   //-----------------------------------------------------------------
   DecimalPoints = 1;
   double x = SymbolInfoDouble(Symbol(), SYMBOL_VOLUME_STEP) * 10;
   while (x < 1)
   { x *= 10; DecimalPoints += 1; }
   //adjusting point base on 4 digit broker for converting pip to point
   point = _Point;
   if (_Digits == 3 || _Digits == 5) point *= 10;
   //-----------------------------------------------------------------
   //create handler for atr indicator
//   AtrHandle = iATR(Symbol(), 0, atrPeriod);
   //-----------------------------------------------------------------
   ttlSlope = SLOPE_NONE; btlSlope = SLOPE_NONE;
   trade.SetExpertMagicNumber(MagicNumber);
   //-----------------------------------------------------------------
  ArraySetAsSeries(haOBuffer,true);  
  ArraySetAsSeries(haCBuffer,true);  
  ArraySetAsSeries(haHBuffer,true);  
  ArraySetAsSeries(haLBuffer,true);  
  haHandle = iCustom(NULL,0,"iheikenashism",MAPeriod,MAMethod,SmPeriod,SmMethod);
   
}
//+------------------------------------------------------------------+
void OnDeinit(const int reason){}
   //-----------------------------------------------------------------

void OnTick()
{ bool old_tick = false;
  datetime Time[];
  ArraySetAsSeries(Time,true);
  CopyTime(_Symbol,_Period,0,1,Time);
  if (lastexec_minute == Time[0]) old_tick = true;
  lastexec_minute = Time[0];
  
//if(old_tick) return;  
//------------------------------------------------------------------------------
MqlRates rt[3];
   if (CopyRates(Symbol(), 0, 1, 3, rt) < 3) return;
   O = rt[2].open;  O1 = rt[1].open;  O2 = rt[0].open;
   H = rt[2].high;  H1 = rt[1].high;  H2 = rt[0].high;
   L = rt[2].low;   L1 = rt[1].low;   L2 = rt[0].low;
   C = rt[2].close; C1 = rt[1].close; C2 = rt[0].close;
//========================HEIKEN ASHI CANDLES CALCULATION========================
  CopyBuffer(haHandle, 0, 1, BarsAgo, haOBuffer);        haO = haOBuffer[0];        haO1 = haOBuffer[1];
  CopyBuffer(haHandle, 1, 1, BarsAgo, haHBuffer);        haH = haHBuffer[0];        haH1 = haHBuffer[1];
  CopyBuffer(haHandle, 2, 1, BarsAgo, haLBuffer);        haL = haLBuffer[0];        haL1 = haLBuffer[1];
  CopyBuffer(haHandle, 3, 1, BarsAgo, haCBuffer);        haC = haCBuffer[0];        haC1 = haCBuffer[1];
//==========================================================================  
  CiStochastic i_stoc;  i_stoc.Create(Symbol(),0,kPeriod,dPeriod,Slowing, stocMAmethod,stocPrice);  i_stoc.Refresh();
  stocmain = NormalizeDouble(i_stoc.Main(stocShift),2);
  stocsignal = NormalizeDouble(i_stoc.Signal(stocShift),2);
  stocsignal1 = NormalizeDouble(i_stoc.Signal(stocShift + 1),2);
//========================================================================
   //-----------------adjust uppert and lower zones
   AdjustLines();
   //-----------------------------------------------------------------
   double Ask = NormalizeDouble(SymbolInfoDouble(Symbol(), SYMBOL_ASK), _Digits);
   double Bid = NormalizeDouble(SymbolInfoDouble(Symbol(), SYMBOL_BID), _Digits);
   double spread = Ask - Bid;
//=====================================================================================
   for (int i = OrdersTotal() - 1; i >= 0; i--)
   {
      double orderTP = ND(OrderGetDouble(ORDER_TP)), orderSL = ND(OrderGetDouble(ORDER_SL)), orderPrice = ND(OrderGetDouble(ORDER_PRICE_OPEN));
      double sl=0,tp=0, price=0;
      
      ulong ticket = OrderGetTicket(i);
      if (OrderSelect(ticket))
      {
         if (OrderGetString(ORDER_SYMBOL) == Symbol())
         {
            if(OrderGetInteger(ORDER_TYPE) == ORDER_TYPE_BUY_STOP )
            
            {  if(ObjectFind(0,tpHLINE) < 0 && ObjectFind(0,topTrendLine) < 0 )                                              tp = orderTP;         else
               if(ObjectFind(0,tpHLINE) >= 0 && ObjectFind(0,topTrendLine) >= 0 && ttlBreakout)                              tp = ND(tpLL);        else
               if(ObjectFind(0,topTrendLine) >= 0)                                                                           tp = ND(topLL);       else 
               if(ObjectFind(0,tpHLINE) >= 0)                                                                                tp = ND(tpLL);     
         
               if(ObjectFind(0,bottomTrendLine) >= 0 && btlSlope == SLOPE_UP)                                                sl = ND(botLL);       else
               if(ObjectFind(0,slHLINE) >= 0)                                                                                sl = ND(slLL);        else
               if(ObjectFind(0,slHLINE) < 0 && ObjectFind(0,bottomTrendLine) < 0)                                            sl = ND(GetLowest(1,BarsForSL));
               
               if(orderPrice > haH)                                                                                          price = haH;
      
               if (sl > orderSL || tp != orderTP || price < orderPrice)
                  trade.OrderModify(ticket, price, sl, tp, ORDER_TIME_GTC, 0);
            }
            if(OrderGetInteger(ORDER_TYPE) == ORDER_TYPE_SELL_STOP )
            
            {  if(ObjectFind(0,tpHLINE) < 0 && ObjectFind(0,bottomTrendLine) < 0 )                                            tp = orderTP;     else
               if(ObjectFind(0,tpHLINE) >= 0 && ObjectFind(0,bottomTrendLine) >= 0 && btlBreakout)                            tp = ND(tpUL);    else
               if(ObjectFind(0,bottomTrendLine) >= 0)                                                                         tp = ND(botUL);   else
               if(ObjectFind(0,tpHLINE) >= 0)                                                                                 tp = ND(tpUL);    
            
               if(ObjectFind(0,topTrendLine) >= 0 && ttlSlope == SLOPE_DOWN)                                                  sl = ND(topUL);   else 
               if(ObjectFind(0,slHLINE) >= 0)                                                                                 sl = ND(slUL);    else
               if(ObjectFind(0,slHLINE) < 0 && ObjectFind(0,topTrendLine) < 0)                                                sl = ND(GetHighest(1,BarsForSL));
               
               if(orderPrice < haL)                                                                                           price = haL;
         
               if (sl != orderSL || tp != orderTP || price > orderPrice)
                  trade.OrderModify(ticket, price, sl, tp, ORDER_TIME_GTC, 0);
            }            
         }
      }
   }
//=============================TRAILING OPENED POSITIONS
   if (PositionSelect(Symbol())  )
   
   {  double posTP = ND(PositionGetDouble(POSITION_TP)), posSL = ND(PositionGetDouble(POSITION_SL));
      double posRisk  = ND(MathAbs(PositionGetDouble(POSITION_PRICE_OPEN) - PositionGetDouble(POSITION_SL)));
      double sl,tp;
      
       if (!EveryTickTS && old_tick) return;
      
      if (PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_BUY)
      
      {  if(ObjectFind(0,topTrendLine) >= 0 )                                                                          tp = ND(topLL);   else 
         if(ObjectFind(0,tpHLINE) >= 0)                                                                                tp = ND(tpLL);    
 //        if(ObjectFind(0,tpHLINE) < 0 && ObjectFind(0,topTrendLine) < 0 )                                              tp = posTP;
         
         if(haTrail && stocsignal > (100-stocLevel))                                                                   sl = haL;         else
         if(ObjectFind(0,bottomTrendLine) >= 0 && btlSlope == SLOPE_UP)                                                sl = ND(botLL);   else
         if(ObjectFind(0,slHLINE) >= 0)                                                                                sl = ND(slLL);    else
         if(ObjectFind(0,slHLINE) < 0 && ObjectFind(0,bottomTrendLine) < 0)                                            sl = posSL;       
      
         if (sl != posSL || tp != posTP)
           trade.PositionModify(Symbol(), ND(sl), ND(tp));
           
         if (ObjectFind(0,beLINE) >= 0 && Ask >= hpcLL)
           { trade.PositionOpen(Symbol(), ORDER_TYPE_SELL, PositionGetDouble(POSITION_VOLUME)/2, Ask, 0, 0, "osd");      
            trade.PositionModify(Symbol(), PositionGetDouble(POSITION_PRICE_OPEN), ND(posTP));
            ObjectDelete(0,beLINE);}
                 
      }
      if (PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_SELL)
      
      {  if(ObjectFind(0,bottomTrendLine) >= 0 )                                                                        tp = ND(botUL);   else
         if(ObjectFind(0,tpHLINE) >= 0)                                                                                 tp = ND(tpUL);   
     //    if(ObjectFind(0,tpHLINE) < 0 && ObjectFind(0,bottomTrendLine) < 0 )                                            tp = posTP;
      
         if(haTrail && stocsignal <= stocLevel)                                                                         sl = haH;         else
         if(ObjectFind(0,topTrendLine) >= 0 && ttlSlope == SLOPE_DOWN)                                                  sl = ND(topUL);   else 
         if(ObjectFind(0,slHLINE) >= 0)                                                                                 sl = ND(slUL);    else
         if(ObjectFind(0,slHLINE) < 0 && ObjectFind(0,topTrendLine) < 0)                                                sl = posSL;       
         
      
         if (sl != posSL || tp != posTP)
            trade.PositionModify(Symbol(), ND(sl), ND(tp));
            
         if (ObjectFind(0,beLINE) >= 0 && Bid <= hpcUL)
           { trade.PositionOpen(Symbol(), ORDER_TYPE_BUY, PositionGetDouble(POSITION_VOLUME)/2, Bid, 0, 0, "osd");
            trade.PositionModify(Symbol(), PositionGetDouble(POSITION_PRICE_OPEN), ND(posTP));   
            ObjectDelete(0,beLINE);}
                     
      } old_tick = true;
   }
   //==================================================
 //       if (!EveryTickTS && old_tick) return;
 
 //--------HA ENTRY---------------------------------------
   if(haEntry && haC < haO && (ObjectFind(0,slHLINE) >= 0 || (ObjectFind(0,bottomTrendLine) >= 0  && btlSlope == SLOPE_UP)))
      SetOrder(ORDER_TYPE_BUY_STOP,ND(haH), magicLong);
      
   if(haEntry && haC > haO && (ObjectFind(0,slHLINE) >= 0 || (ObjectFind(0,topTrendLine) >= 0 && ttlSlope == SLOPE_DOWN)))
      SetOrder(ORDER_TYPE_SELL_STOP,ND(haL), magicShort);
      
   //---ENTRY HORIZONTAL LINE LONG BREAKOUT ------------------
   if (stocmain > stocsignal && stocsignal > stocsignal1 && (tpML > entryML || topLL > entryML) && entryML != 0 && C > O && O <= entryML && C > entryML)
      SetOrder(ORDER_TYPE_BUY_STOP, ND(MathMax(entryUL,H)), magicLong); 
      
   //---ENTRY HORIZONTAL LINE LONG BOUNCE ------------------
   if (stocmain < stocsignal && stocsignal < stocsignal1 && (tpML > entryML || (topLL > entryML && ttlSlope == SLOPE_DOWN) ) && (H >= entryUL || H1 >= entryUL) && (L <= entryUL || L1 <= entryUL)&& (C > entryML || C1 >= entryML) && (C > O || C1 > O1))
      SetOrder(ORDER_TYPE_BUY_STOP, ND(MathMax(H, entryUL)), magicLong);  
      
   //---ENTRY HORIZONTAL LINE SHORT BREAKOUT ------------------
   if (stocsignal > (100 - stocLevel) && (tpML < entryML || botUL < entryML) && entryML != 0 && C < O && O >= entryML && C < entryML)
      SetOrder(ORDER_TYPE_SELL_STOP, ND(MathMin(entryLL,L)), magicShort); 
      
   //---ENTRY HORIZONTAL LINE SHORT BOUNCE ------------------
   if (stocsignal > (100 - stocLevel) &&(tpML < entryML || (botUL < entryML && btlSlope == SLOPE_UP)) && (L <= entryLL || L1 <= entryLL) && (H >= entryLL || H1 >= entryLL)&& (C <= entryML || C1 <= entryML) && (C < O || C1 < O1))
      SetOrder(ORDER_TYPE_SELL_STOP, ND(MathMin(L, entryLL)), magicShort); 
   
//======================TOP TRENDLLINE LONG BREAKOUT ============================================
   if (ttlBreakout && ttlSlope == SLOPE_DOWN && topML != 0 && C > O && (O <= topML || O1 <= topML) && C > topML)
      SetOrder(ORDER_TYPE_BUY_STOP, ND(MathMax(topUL,H)), magicLong);
      
//=====================TOP TRENDLLINE SHORT BREAKOUT===========================================
   if (ttlBreakout && ttlSlope == SLOPE_UP && topML != 0 && C < O && (O >= topML || O1 >= topML) && C < topML)
      SetOrder(ORDER_TYPE_SELL_STOP, ND(MathMin(topLL,L)), magicShort);
      
//=======================TOP TRENDLLINE SHORT BOUNCE ============================================
   if (ttlBounce && ttlSlope ==SLOPE_DOWN && topLL != 0 && 
         (L <= topLL || L1 <= topLL) && (H >= topLL || H1 >= topLL)&& (C < topML || C1 <= topML) && (C < O || C1 < O1))
            SetOrder(ORDER_TYPE_SELL_STOP, ND(MathMin(L, topLL)), magicShort);
//================================TOP TRENDLLINE LONG BOUNCE =====================================
   if (ttlBounce && ttlSlope == SLOPE_UP && topUL != 0 && 
   (H >= topUL || H1 >= topUL) && (L <= topUL || L1 <= topUL)&& (C > topML || C1 >= topML) && (C > O || C1 > O1))
      SetOrder(ORDER_TYPE_BUY_STOP, ND(MathMax(H, topUL)), magicLong);
//====================================BOTTOM TRENDLLINE LONG BREAKOUT======================================
   if (btlBreakout && btlSlope == SLOPE_DOWN && botML != 0 && C > O && (O <= botML || O <= botML) && C > botML)
      SetOrder(ORDER_TYPE_BUY_STOP, ND(MathMax(botUL,H)), magicLong);
      
//=============================BOTTOM TRENDLLINE SHORT BREAKOUT ==============================================
   if (btlBreakout && btlSlope == SLOPE_UP && botML != 0 && C < O && (O >= botML || O >= botML) && C < botML)
      SetOrder(ORDER_TYPE_SELL_STOP, ND(MathMin(botLL,L)), magicShort);
      
//==================================BOTTOM TRENDLLINE SHORT BOUNCE ================================================
   if (btlBounce && btlSlope == SLOPE_DOWN && botLL != 0 && 
   (L <= botLL || L1 <= botLL) && (H >= botLL || H1 >= botLL)&& (C <= botML || C1 <= botML) && (C < O || C1 < O1))
      SetOrder(ORDER_TYPE_SELL_STOP, ND(MathMin(L1,botLL)), magicShort);
//====================================BOTTOM TRENDLLINE LONG BOUNCE ================================================
   if (btlBounce && btlSlope == SLOPE_UP && botUL != 0 && 
   (H >= botUL || H1 >= botUL) && (L <= botUL || L1 <= botUL)&& (C >= botML || C1 >= botML) && (C > O && C1 > O1))
      SetOrder(ORDER_TYPE_BUY_STOP, ND(MathMax(H1, botUL)), magicLong);
   //-----------------------------------------------------------------
 //  if (useTrailingStop) TrailPosition();
   //-----------------------------------------------------------------
 //  old_tick = true;
}

//+------------------------------------------------------------------+
// place a pending order at specified level
void SetOrder(ENUM_ORDER_TYPE type, double price, string magic)
{     datetime dt[1];
   if (CopyTime(Symbol(), 0, 0, 1, dt) < 1) return;
   bool placed = false;
   int count = 0;
   for (int i = OrdersTotal() - 1; i >= 0; i--)
   {
      ulong ticket = OrderGetTicket(i);
      if (OrderSelect(ticket))
      {
         if (OrderGetString(ORDER_SYMBOL) == Symbol())
         {
            count ++;
            if (OrderGetString(ORDER_COMMENT) == magic) placed = true;
            if (placed && OrderGetInteger(ORDER_TIME_SETUP) < dt[0])
               if (NormalizeDouble(price, _Digits) != NormalizeDouble(OrderGetDouble(ORDER_PRICE_OPEN), _Digits))
                  trade.OrderModify(ticket, price, OrderGetDouble(ORDER_SL), OrderGetDouble(ORDER_TP), ORDER_TIME_GTC, 0);
         }
      }
   }
   //-----------------------------------------------------------------
   //count no of filled pendings
   ulong ticket;
   HistorySelect(TimeCurrent() - 30 * 24 * 60 * 60, TimeCurrent());
   for (int i = HistoryDealsTotal() - 1 ; i >= 0; i--)
   {
      ticket = HistoryDealGetTicket(i);
      if (HistoryDealGetString(ticket, DEAL_SYMBOL) == Symbol())
      {
         if (HistoryDealGetInteger(ticket, DEAL_ENTRY) == DEAL_ENTRY_OUT) break;
         if (HistoryDealGetInteger(ticket, DEAL_ENTRY) == DEAL_ENTRY_IN && HistoryDealGetInteger(ticket, DEAL_MAGIC) == MagicNumber)
         {
            count ++;
            if (HistoryDealGetString(ticket, DEAL_COMMENT) == magic) placed = true;
         }
      }
   }
   //-----------------------------------------------------------------
   //no order placed so place new one if max orders not exceeded
   if (!placed && count < maxNumberOfEntries)
   {
      //-----------------------------------------------------------------
      string t;
      if (type == ORDER_TYPE_BUY_STOP) t = "buy stop";
      if (type == ORDER_TYPE_SELL_STOP) t = "sell stop";
      //-----------------------------------------------------------------
      double sl = 0, tp = 0;
      string msg;
      if (type == ORDER_TYPE_BUY_STOP)
        { if(ObjectFind(0, bottomTrendLine) >= 0 && btlSlope == SLOPE_UP)                             sl = ND(botLL); else
          if(ObjectFind(0,slHLINE) >= 0)                                                              sl = ND(slLL);  else 
          if(ObjectFind(0, bottomTrendLine) < 0 && ObjectFind(0,slHLINE) < 0)                         sl = ND(GetLowest(1,BarsForSL));   
          
          if(ObjectFind(0, topTrendLine) >= 0 && ttlSlope == SLOPE_DOWN && ttlBreakout == false)      tp = ND(topLL); else tp = ND(tpLL);      
        }
      
      if (type == ORDER_TYPE_SELL_STOP)
         {if (ObjectFind(0, topTrendLine) >= 0 && ttlSlope == SLOPE_DOWN)                             sl = ND(topUL); else 
          if(ObjectFind(0,slHLINE) >= 0)                                                              sl = ND(slUL);  else   
          if(ObjectFind(0, topTrendLine) < 0 && ObjectFind(0,slHLINE) < 0)                            sl = ND(GetHighest(1,BarsForSL));  
           
          if(ObjectFind(0,bottomTrendLine) >= 0 && btlSlope == SLOPE_UP && btlBreakout == false)      tp = ND(botUL); else tp = ND(tpUL);
      }
      double lot = lotSize;
      if (risk != 0)
      {
         double pv = SymbolInfoDouble(Symbol(), SYMBOL_TRADE_TICK_VALUE)/SymbolInfoDouble(Symbol(), SYMBOL_TRADE_TICK_SIZE);
         double bal = AccountInfoDouble(ACCOUNT_FREEMARGIN);
         lot = MathFloor(bal * risk / (100 * MathAbs(price - sl) * pv) * MathPow(10, DecimalPoints)) / MathPow(10, DecimalPoints);
         lot = NormalizeDouble(lot, DecimalPoints);
      }
      if (trade.OrderOpen(Symbol(), type, lot, 0, price, sl, tp, ORDER_TIME_GTC, 0, magic)) Print(msg);
   }
}
//+------------------------------------------------------------------+
/*/ logic for trailing goes here
void TrailPosition()
{
   double sl, sl2, tp;
   double atr[1];
   if (PositionSelect(Symbol()))
   {
      sl = PositionGetDouble(POSITION_SL); tp = PositionGetDouble(POSITION_TP);
      sl2 = 0;
      if (PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_BUY)
      {
         if (atrMultiplier != 0)
         {
            if (CopyBuffer(AtrHandle, 0, 1, 1, atr) < 1) return;
            sl2 = SymbolInfoDouble(Symbol(), SYMBOL_BID) - atrMultiplier * atr[0];
         }
         else if((useHATRAIL) && stocsignal >  (100-stocLevel))
            sl2 = ND(L);
            
         if (sl2 != 0 && (sl == 0 || sl2 > sl)) trade.PositionModify(Symbol(), sl2, tp);
      }
      if (PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_SELL)
      {
         if (atrMultiplier != 0)
         {
            if (CopyBuffer(AtrHandle, 0, 1, 1, atr) < 1) return;
            sl2 = SymbolInfoDouble(Symbol(), SYMBOL_ASK) + atrMultiplier * atr[0];
         }
         else if((useHATRAIL) && stocsignal < stocLevel)
            sl2 = ND(H);

         if (sl2 != 0 && (sl == 0 || sl2 < sl)) trade.PositionModify(Symbol(), sl2, tp);
      }
   }
}*/
//+------------------------------------------------------------------+
// remove pending order at specified level if exists
void RemoveOrder(string magic)
{
   for (int i = OrdersTotal() - 1; i >= 0; i--)
   {
      ulong ticket = OrderGetTicket(i);
      if (OrderSelect(ticket))
         if (OrderGetString(ORDER_SYMBOL) == Symbol() && OrderGetString(ORDER_COMMENT) == magic)
            trade.OrderDelete(ticket);
   }
}
//+------------------------------------------------------------------+
void AdjustLines()
{
   //-----------------------------------------------------------------
   double price,priceUP,priceDN;
   //-----------------------------------------------------------------
   //reset line and zone prices for current candle
   tpUL = 0; tpML = 0; tpLL = 0;
   slUL = 0; slML = 0; slLL = 0;
   entryUL = 0; entryML = 0; entryLL = 0;
   
//=========================ENTRY HORIZONTAL LINE======================================
   if (ObjectFind(0, entryHLINE) >= 0)
   { price = ND(ObjectGetDouble(0, entryHLINE, OBJPROP_PRICE, 0));
      //draw entryHLINE upper line
      if(ObjectFind(0, "High" + entryHLINE) < 0)
         ObjectCreate(0, "High" + entryHLINE, OBJ_HLINE, 0, 0, price + StepUP_DN * point);
         ObjectSetInteger(0, "High" + entryHLINE, OBJPROP_STYLE, STYLE_DOT);
         ObjectSetInteger(0, "High" + entryHLINE, OBJPROP_COLOR, ObjectGetInteger(0, entryHLINE, OBJPROP_COLOR));
      priceUP = price + StepUP_DN * point;
      if (ObjectGetDouble(0, "High" + entryHLINE, OBJPROP_PRICE, 0) != priceUP)
         ObjectSetDouble(0, "High" + entryHLINE, OBJPROP_PRICE, 0, priceUP);
      //draw entryHLINE lower line
      if (ObjectFind(0, "Low" + entryHLINE) < 0)
         ObjectCreate(0, "Low" + entryHLINE, OBJ_HLINE, 0, 0, price - StepUP_DN * point);
      ObjectSetInteger(0, "Low" + entryHLINE, OBJPROP_STYLE, STYLE_DOT);
      ObjectSetInteger(0, "Low" + entryHLINE, OBJPROP_COLOR, ObjectGetInteger(0, entryHLINE, OBJPROP_COLOR));
      priceDN = price - StepUP_DN * point;
      if (ObjectGetDouble(0, "Low" + entryHLINE, OBJPROP_PRICE, 0) != priceDN)
         ObjectSetDouble(0, "Low" + entryHLINE, OBJPROP_PRICE, 0, priceDN);
      
      entryUL = ND(ObjectGetDouble(0,"High" + entryHLINE,OBJPROP_PRICE,0));
      entryML = ND(ObjectGetDouble(0, entryHLINE,OBJPROP_PRICE,0));
      entryLL = ND(ObjectGetDouble(0,"Low" + entryHLINE,OBJPROP_PRICE,0));
   }  else  {  if (ObjectFind(0, "High" + entryHLINE) >= 0) ObjectDelete(0, "High" + entryHLINE);
               if (ObjectFind(0, "Low" + entryHLINE) >= 0) ObjectDelete(0, "Low" + entryHLINE);
            }
//=========================TP HORIZONTAL LINE======================================
   if (ObjectFind(0, tpHLINE) >= 0)   
   { price = ND(ObjectGetDouble(0, tpHLINE, OBJPROP_PRICE, 0));if(ObjectFind(0, "High" + tpHLINE) < 0)
         ObjectCreate(0, "High" + tpHLINE, OBJ_HLINE, 0, 0, price + StepUP_DN * point);
         ObjectSetInteger(0, "High" + tpHLINE, OBJPROP_STYLE, STYLE_DOT);
         ObjectSetInteger(0, "High" + tpHLINE, OBJPROP_COLOR, ObjectGetInteger(0, tpHLINE, OBJPROP_COLOR));
      priceUP = price + StepUP_DN * point;
      if (ObjectGetDouble(0, "High" + tpHLINE, OBJPROP_PRICE, 0) != priceUP)
         ObjectSetDouble(0, "High" + tpHLINE, OBJPROP_PRICE, 0, priceUP);
      //draw tpHLINE lower line
      if (ObjectFind(0, "Low" + tpHLINE) < 0)
         ObjectCreate(0, "Low" + tpHLINE, OBJ_HLINE, 0, 0, price - StepUP_DN * point);
      ObjectSetInteger(0, "Low" + tpHLINE, OBJPROP_STYLE, STYLE_DOT);
      ObjectSetInteger(0, "Low" + tpHLINE, OBJPROP_COLOR, ObjectGetInteger(0, tpHLINE, OBJPROP_COLOR));
      priceDN = price - StepUP_DN * point;
      if (ObjectGetDouble(0, "Low" + tpHLINE, OBJPROP_PRICE, 0) != priceDN)
         ObjectSetDouble(0, "Low" + tpHLINE, OBJPROP_PRICE, 0, priceDN);
      
      tpUL = ND(ObjectGetDouble(0,"High" + tpHLINE,OBJPROP_PRICE,0));
      tpML = ND(ObjectGetDouble(0, tpHLINE,OBJPROP_PRICE,0));
      tpLL = ND(ObjectGetDouble(0,"Low" + tpHLINE,OBJPROP_PRICE,0));
   }  else  {  if (ObjectFind(0, "High" + tpHLINE) >= 0) ObjectDelete(0, "High" + tpHLINE);
               if (ObjectFind(0, "Low" + tpHLINE) >= 0) ObjectDelete(0, "Low" + tpHLINE);
            }
//============================STOP LOSS HORIZONTAL LINE========================================
   if (ObjectFind(0, slHLINE) >= 0)
   { price = ND(ObjectGetDouble(0, slHLINE, OBJPROP_PRICE, 0));
      //draw slHLINE upper line
      if(ObjectFind(0, "High" + slHLINE) < 0)
         ObjectCreate(0, "High" + slHLINE, OBJ_HLINE, 0, 0, price + StepUP_DN * point);
         ObjectSetInteger(0, "High" + slHLINE, OBJPROP_STYLE, STYLE_DOT);
         ObjectSetInteger(0, "High" + slHLINE, OBJPROP_COLOR, ObjectGetInteger(0, slHLINE, OBJPROP_COLOR));
      priceUP = price + StepUP_DN * point;
      if (ObjectGetDouble(0, "High" + slHLINE, OBJPROP_PRICE, 0) != priceUP)
         ObjectSetDouble(0, "High" + slHLINE, OBJPROP_PRICE, 0, priceUP);
      //draw slHLINE lower line
      if (ObjectFind(0, "Low" + slHLINE) < 0)
         ObjectCreate(0, "Low" + slHLINE, OBJ_HLINE, 0, 0, price - StepUP_DN * point);
      ObjectSetInteger(0, "Low" + slHLINE, OBJPROP_STYLE, STYLE_DOT);
      ObjectSetInteger(0, "Low" + slHLINE, OBJPROP_COLOR, ObjectGetInteger(0, slHLINE, OBJPROP_COLOR));
      priceDN = price - StepUP_DN * point;
      if (ObjectGetDouble(0, "Low" + slHLINE, OBJPROP_PRICE, 0) != priceDN)
         ObjectSetDouble(0, "Low" + slHLINE, OBJPROP_PRICE, 0, priceDN);
      
      slUL = ND(ObjectGetDouble(0,"High" + slHLINE,OBJPROP_PRICE,0));
      slML = ND(ObjectGetDouble(0, slHLINE,OBJPROP_PRICE,0));
      slLL = ND(ObjectGetDouble(0,"Low" + slHLINE,OBJPROP_PRICE,0));
   }  else  {  if (ObjectFind(0, "High" + slHLINE) >= 0) ObjectDelete(0, "High" + slHLINE);
               if (ObjectFind(0, "Low" + slHLINE) >= 0) ObjectDelete(0, "Low" + slHLINE);
            }
            
//============================HALF POSITION HORIZONTAL LINE========================================
   if (ObjectFind(0, beLINE) >= 0)
   { price = ND(ObjectGetDouble(0, beLINE, OBJPROP_PRICE, 0));
      //draw beLINE upper line
      if(ObjectFind(0, "High" + beLINE) < 0)
         ObjectCreate(0, "High" + beLINE, OBJ_HLINE, 0, 0, price + StepUP_DN * point);
         ObjectSetInteger(0, "High" + beLINE, OBJPROP_STYLE, STYLE_DOT);
         ObjectSetInteger(0, "High" + beLINE, OBJPROP_COLOR, ObjectGetInteger(0, beLINE, OBJPROP_COLOR));
      priceUP = price + StepUP_DN * point;
      if (ObjectGetDouble(0, "High" + beLINE, OBJPROP_PRICE, 0) != priceUP)
         ObjectSetDouble(0, "High" + beLINE, OBJPROP_PRICE, 0, priceUP);
      //draw beLINE lower line
      if (ObjectFind(0, "Low" + beLINE) < 0)
         ObjectCreate(0, "Low" + beLINE, OBJ_HLINE, 0, 0, price - StepUP_DN * point);
      ObjectSetInteger(0, "Low" + beLINE, OBJPROP_STYLE, STYLE_DOT);
      ObjectSetInteger(0, "Low" + beLINE, OBJPROP_COLOR, ObjectGetInteger(0, beLINE, OBJPROP_COLOR));
      priceDN = price - StepUP_DN * point;
      if (ObjectGetDouble(0, "Low" + beLINE, OBJPROP_PRICE, 0) != priceDN)
         ObjectSetDouble(0, "Low" + beLINE, OBJPROP_PRICE, 0, priceDN);
      
      hpcUL = ND(ObjectGetDouble(0,"High" + beLINE,OBJPROP_PRICE,0));
      hpcML = ND(ObjectGetDouble(0, beLINE,OBJPROP_PRICE,0));
      hpcLL = ND(ObjectGetDouble(0,"Low" + beLINE,OBJPROP_PRICE,0));
   }  else  {  if (ObjectFind(0, "High" + beLINE) >= 0) ObjectDelete(0, "High" + beLINE);
               if (ObjectFind(0, "Low" + beLINE) >= 0) ObjectDelete(0, "Low" + beLINE);
            }
//===================================TRENDLINES===================================          
   double price1, price2, price11, price21;
   ulong time1, time2;
   datetime dt[1];
   if (CopyTime(Symbol(), 0, 0, 1, dt) < 1) return;
   //-----------------------------------------------------------------
   //reset line and zone prices for current candle
   topUL = 0; topML = 0; topLL = 0;
   botUL = 0; botML = 0; botLL = 0;
   //-----------------------------------------------------------------
   if (ObjectFind(0, topTrendLine) >= 0)
   {
      price1 = NormalizeDouble(ObjectGetDouble(0, topTrendLine, OBJPROP_PRICE, 0), _Digits);
      time1 = ObjectGetInteger(0, topTrendLine, OBJPROP_TIME, 0);
      price2 = NormalizeDouble(ObjectGetDouble(0, topTrendLine, OBJPROP_PRICE, 1), _Digits);
      time2 = ObjectGetInteger(0, topTrendLine, OBJPROP_TIME, 1);
      ttlSlope = SLOPE_NONE;
      if ((time1 < time2 && price1 < price2) || (time1 > time2 && price1 > price2)) ttlSlope = SLOPE_UP;
      if ((time1 < time2 && price1 > price2) || (time1 > time2 && price1 < price2)) ttlSlope = SLOPE_DOWN;
      //draw topTrendLine upper line
      if (ObjectFind(0, "High" + topTrendLine) < 0)
         ObjectCreate(0, "High" + topTrendLine, OBJ_TREND, 0, time1, price1 + StepUP_DN * point, time2, price2 + StepUP_DN * point);
      ObjectSetInteger(0, "High" + topTrendLine, OBJPROP_STYLE, STYLE_DOT);
      ObjectSetInteger(0, "High" + topTrendLine, OBJPROP_RAY, ObjectGetInteger(0, topTrendLine, OBJPROP_RAY));
      ObjectSetInteger(0, "High" + topTrendLine, OBJPROP_RAY_LEFT, ObjectGetInteger(0, topTrendLine, OBJPROP_RAY_LEFT));
      ObjectSetInteger(0, "High" + topTrendLine, OBJPROP_RAY_RIGHT, ObjectGetInteger(0, topTrendLine, OBJPROP_RAY_RIGHT));
      ObjectSetInteger(0, "High" + topTrendLine, OBJPROP_COLOR, ObjectGetInteger(0, topTrendLine, OBJPROP_COLOR));
      price11 = price1 + StepUP_DN * point;
      price21 = price2 + StepUP_DN * point;
      if (ObjectGetDouble(0, "High" + topTrendLine, OBJPROP_PRICE, 0) != price11)
         ObjectSetDouble(0, "High" + topTrendLine, OBJPROP_PRICE, 0, price11);
      if (ObjectGetDouble(0, "High" + topTrendLine, OBJPROP_PRICE, 1) != price21)
         ObjectSetDouble(0, "High" + topTrendLine, OBJPROP_PRICE, 1, price21);
      if (ObjectGetInteger(0, "High" + topTrendLine, OBJPROP_TIME, 0) != time1)
         ObjectSetInteger(0, "High" + topTrendLine, OBJPROP_TIME, 0, time1);
      if (ObjectGetInteger(0, "High" + topTrendLine, OBJPROP_TIME, 1) != time2)
         ObjectSetInteger(0, "High" + topTrendLine, OBJPROP_TIME, 1, time2);
      //draw topTrendLine lower line
      if (ObjectFind(0, "Low" + topTrendLine) < 0)
         ObjectCreate(0, "Low" + topTrendLine, OBJ_TREND, 0, time1, price1 - StepUP_DN * point, time2, price2 - StepUP_DN * point);
      ObjectSetInteger(0, "Low" + topTrendLine, OBJPROP_STYLE, STYLE_DOT);
      ObjectSetInteger(0, "Low" + topTrendLine, OBJPROP_RAY, ObjectGetInteger(0, topTrendLine, OBJPROP_RAY));
      ObjectSetInteger(0, "Low" + topTrendLine, OBJPROP_RAY_LEFT, ObjectGetInteger(0, topTrendLine, OBJPROP_RAY_LEFT));
      ObjectSetInteger(0, "Low" + topTrendLine, OBJPROP_RAY_RIGHT, ObjectGetInteger(0, topTrendLine, OBJPROP_RAY_RIGHT));
      ObjectSetInteger(0, "Low" + topTrendLine, OBJPROP_COLOR, ObjectGetInteger(0, topTrendLine, OBJPROP_COLOR));
      price11 = price1 - StepUP_DN * point;
      price21 = price2 - StepUP_DN * point;
      if (ObjectGetDouble(0, "Low" + topTrendLine, OBJPROP_PRICE, 0) != price11)
         ObjectSetDouble(0, "Low" + topTrendLine, OBJPROP_PRICE, 0, price11);
      if (ObjectGetDouble(0, "Low" + topTrendLine, OBJPROP_PRICE, 1) != price21)
         ObjectSetDouble(0, "Low" + topTrendLine, OBJPROP_PRICE, 1, price21);
      if (ObjectGetInteger(0, "Low" + topTrendLine, OBJPROP_TIME, 0) != time1)
         ObjectSetInteger(0, "Low" + topTrendLine, OBJPROP_TIME, 0, time1);
      if (ObjectGetInteger(0, "Low" + topTrendLine, OBJPROP_TIME, 1) != time2)
         ObjectSetInteger(0, "Low" + topTrendLine, OBJPROP_TIME, 1, time2);
      topUL = NormalizeDouble(ObjectGetValueByTime(0, "High"+topTrendLine, dt[0]),_Digits);
      topML = NormalizeDouble(ObjectGetValueByTime(0, topTrendLine, dt[0]),_Digits);
      topLL = NormalizeDouble(ObjectGetValueByTime(0, "Low"+topTrendLine, dt[0]),_Digits);
   }
   else
   {
      if (ObjectFind(0, "High" + topTrendLine) >= 0) ObjectDelete(0, "High" + topTrendLine);
      if (ObjectFind(0, "Low" + topTrendLine) >= 0) ObjectDelete(0, "Low" + topTrendLine);
   }
   //-----------------------------------------------------------------
   if(ObjectFind(0, bottomTrendLine) >= 0)
   {
      price1 = NormalizeDouble(ObjectGetDouble(0, bottomTrendLine, OBJPROP_PRICE, 0), _Digits);
      time1 = ObjectGetInteger(0, bottomTrendLine, OBJPROP_TIME, 0);
      price2 = NormalizeDouble(ObjectGetDouble(0, bottomTrendLine, OBJPROP_PRICE, 1), _Digits);
      time2 = ObjectGetInteger(0, bottomTrendLine, OBJPROP_TIME, 1);
      btlSlope = SLOPE_NONE;
      if ((time1 < time2 && price1 < price2) || (time1 > time2 && price1 > price2)) btlSlope = SLOPE_UP;
      if ((time1 < time2 && price1 > price2) || (time1 > time2 && price1 < price2)) btlSlope = SLOPE_DOWN;
      //draw botTrendLine upper line
      if (ObjectFind(0, "High" + bottomTrendLine) < 0)
         ObjectCreate(0, "High" + bottomTrendLine, OBJ_TREND, 0, time1, price1 + StepUP_DN * point, time2, price2 + StepUP_DN * point);
      ObjectSetInteger(0, "High" + bottomTrendLine, OBJPROP_STYLE, STYLE_DOT);
      ObjectSetInteger(0, "High" + bottomTrendLine, OBJPROP_RAY, ObjectGetInteger(0, bottomTrendLine, OBJPROP_RAY));
      ObjectSetInteger(0, "High" + bottomTrendLine, OBJPROP_RAY_LEFT, ObjectGetInteger(0, bottomTrendLine, OBJPROP_RAY_LEFT));
      ObjectSetInteger(0, "High" + bottomTrendLine, OBJPROP_RAY_RIGHT, ObjectGetInteger(0, bottomTrendLine, OBJPROP_RAY_RIGHT));
      ObjectSetInteger(0, "High" + bottomTrendLine, OBJPROP_COLOR, ObjectGetInteger(0, bottomTrendLine, OBJPROP_COLOR));
      price11 = price1 + StepUP_DN * point;
      price21 = price2 + StepUP_DN * point;
      if (ObjectGetDouble(0, "High" + bottomTrendLine, OBJPROP_PRICE, 0) != price11)
         ObjectSetDouble(0, "High" + bottomTrendLine, OBJPROP_PRICE, 0, price11);
      if (ObjectGetDouble(0, "High" + bottomTrendLine, OBJPROP_PRICE, 1) != price21)
         ObjectSetDouble(0, "High" + bottomTrendLine, OBJPROP_PRICE, 1, price21);
      if (ObjectGetInteger(0, "High" + bottomTrendLine, OBJPROP_TIME, 0) != time1)
         ObjectSetInteger(0, "High" + bottomTrendLine, OBJPROP_TIME, 0, time1);
      if (ObjectGetInteger(0, "High" + bottomTrendLine, OBJPROP_TIME, 1) != time2)
         ObjectSetInteger(0, "High" + bottomTrendLine, OBJPROP_TIME, 1, time2);
      //draw botTrendLine lower line
      if (ObjectFind(0, "Low" + bottomTrendLine) < 0)
         ObjectCreate(0, "Low" + bottomTrendLine, OBJ_TREND, 0, time1, price1 - StepUP_DN * point, time2, price2 - StepUP_DN * point);
      ObjectSetInteger(0, "Low" + bottomTrendLine, OBJPROP_STYLE, STYLE_DOT);
      ObjectSetInteger(0, "Low" + bottomTrendLine, OBJPROP_RAY, ObjectGetInteger(0, bottomTrendLine, OBJPROP_RAY));
      ObjectSetInteger(0, "Low" + bottomTrendLine, OBJPROP_RAY_LEFT, ObjectGetInteger(0, bottomTrendLine, OBJPROP_RAY_LEFT));
      ObjectSetInteger(0, "Low" + bottomTrendLine, OBJPROP_RAY_RIGHT, ObjectGetInteger(0, bottomTrendLine, OBJPROP_RAY_RIGHT));
      ObjectSetInteger(0, "Low" + bottomTrendLine, OBJPROP_COLOR, ObjectGetInteger(0, bottomTrendLine, OBJPROP_COLOR));
      price11 = price1 - StepUP_DN * point;
      price21 = price2 - StepUP_DN * point;
      if (ObjectGetDouble(0, "Low" + bottomTrendLine, OBJPROP_PRICE, 0) != price11)
         ObjectSetDouble(0, "Low" + bottomTrendLine, OBJPROP_PRICE, 0, price11);
      if (ObjectGetDouble(0, "Low" + bottomTrendLine, OBJPROP_PRICE, 1) != price21)
         ObjectSetDouble(0, "Low" + bottomTrendLine, OBJPROP_PRICE, 1, price21);
      if (ObjectGetInteger(0, "Low" + bottomTrendLine, OBJPROP_TIME, 0) != time1)
         ObjectSetInteger(0, "Low" + bottomTrendLine, OBJPROP_TIME, 0, time1);
      if (ObjectGetInteger(0, "Low" + bottomTrendLine, OBJPROP_TIME, 1) != time2)
         ObjectSetInteger(0, "Low" + bottomTrendLine, OBJPROP_TIME, 1, time2);
      botUL = NormalizeDouble(ObjectGetValueByTime(0,"High"+bottomTrendLine, dt[0]),_Digits);
      botML = NormalizeDouble(ObjectGetValueByTime(0,bottomTrendLine, dt[0]),_Digits);
      botLL = NormalizeDouble(ObjectGetValueByTime(0,"Low"+bottomTrendLine, dt[0]),_Digits);
   }
   else
   {
      if (ObjectFind(0, "High" + bottomTrendLine) >= 0) ObjectDelete(0, "High" + bottomTrendLine);
      if (ObjectFind(0, "Low" + bottomTrendLine) >= 0) ObjectDelete(0, "Low" + bottomTrendLine);
   }
   //-----------------------------------------------------------------
}            

//+------------------------------------------------------------------+
double ND(double value) {  return(NormalizeDouble(value, 4)); }
//+------------------------------------------------------------------+
double GetLowest(int start, int count)
{
  double low[];
  ArrayResize(low, count);
  if (CopyLow(Symbol(), 0, start, count, low) < count) return (0);
  return (low[ArrayMinimum(low)]);
}
//+------------------------------------------------------------------+
double GetHighest(int start, int count)
{
  double high[];
  ArrayResize(high, count);
  if (CopyHigh(Symbol(), 0, start, count, high) < count) return (0);
  return (high[ArrayMaximum(high)]);
}